<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">
      <el-form-item label="圈子id" prop="comId">
        <el-input
          v-model="queryParams.comId"
          placeholder="请输入圈子id"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="名片id" prop="identityId">
        <el-input
          v-model="queryParams.identityId"
          placeholder="请输入名片id"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="个人id" prop="commonId">
        <el-input
          v-model="queryParams.commonId"
          placeholder="请输入个人id"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="" prop="gmtCreate">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.gmtCreate"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="" prop="gmtUpdate">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.gmtUpdate"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="删除标识" prop="deleteFlag">
        <el-input
          v-model="queryParams.deleteFlag"
          placeholder="请输入删除标识"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-permission="['unimall:circleCardInfo:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-permission="['unimall:circleCardInfo:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-permission="['unimall:circleCardInfo:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-permission="['unimall:circleCardInfo:export']"
        >导出</el-button>
      </el-col>
    </el-row>

    <el-table v-loading="loading" :data="circleCardInfoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="圈子id" align="center" prop="comId" />
      <el-table-column label="名片id" align="center" prop="identityId" />
      <el-table-column label="个人id" align="center" prop="commonId" />
      <el-table-column label="" align="center" prop="gmtCreate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.gmtCreate) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="" align="center" prop="gmtUpdate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.gmtUpdate) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="删除标识" align="center" prop="deleteFlag" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-permission="['unimall:circleCardInfo:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-permission="['unimall:circleCardInfo:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改圈子个人关系对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="圈子id" prop="comId">
          <el-input v-model="form.comId" placeholder="请输入圈子id" />
        </el-form-item>
        <el-form-item label="名片id" prop="identityId">
          <el-input v-model="form.identityId" placeholder="请输入名片id" />
        </el-form-item>
        <el-form-item label="个人id" prop="commonId">
          <el-input v-model="form.commonId" placeholder="请输入个人id" />
        </el-form-item>
        <el-form-item label="" prop="gmtCreate">
          <el-date-picker clearable size="small" style="width: 200px"
            v-model="form.gmtCreate"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="" prop="gmtUpdate">
          <el-date-picker clearable size="small" style="width: 200px"
            v-model="form.gmtUpdate"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="删除标识" prop="deleteFlag">
          <el-input v-model="form.deleteFlag" placeholder="请输入删除标识" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listCircleCardInfo, getCircleCardInfo, delCircleCardInfo, addCircleCardInfo, updateCircleCardInfo, exportCircleCardInfo } from "@/api/card/circleCardInfo";

export default {
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 圈子个人关系表格数据
      circleCardInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        comId: undefined,
        identityId: undefined,
        commonId: undefined,
        gmtCreate: undefined,
        gmtUpdate: undefined,
        deleteFlag: undefined
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        comId: [
          { required: true, message: "圈子id不能为空", trigger: "blur" }
        ],        identityId: [
          { required: true, message: "名片id不能为空", trigger: "blur" }
        ],        commonId: [
          { required: true, message: "个人id不能为空", trigger: "blur" }
        ],        gmtCreate: [
          { required: true, message: "不能为空", trigger: "blur" }
        ],        gmtUpdate: [
          { required: true, message: "不能为空", trigger: "blur" }
        ],        deleteFlag: [
          { required: true, message: "删除标识不能为空", trigger: "blur" }
        ]      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询圈子个人关系列表 */
    getList() {
      this.loading = true;
      listCircleCardInfo(this.queryParams).then(response => {
        this.circleCardInfoList = response.data.data.items
        this.total = response.data.data.count
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        comId: undefined,
        identityId: undefined,
        commonId: undefined,
        gmtCreate: undefined,
        gmtUpdate: undefined,
        deleteFlag: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.comId)
      this.single = selection.length!=1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加圈子个人关系";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const comId = row.comId || this.ids.join(',')
      getCircleCardInfo(comId).then(response => {
        this.form = response.data.data
        this.open = true;
        this.title = "修改圈子个人关系";
      });
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.comId != undefined) {
            updateCircleCardInfo(this.form).then(response => {
              if (response.data) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          } else {
            addCircleCardInfo(this.form).then(response => {
              if (response.data) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const comIds = row.comId || this.ids.join(',')
      this.$confirm('是否确认删除圈子个人关系编号为"' + comIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCircleCardInfo(comIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有圈子个人关系数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportCircleCardInfo(queryParams);
        }).then(response => {
          this.download(response.data.data);
        }).catch(function() {});
    }
  }
};
</script>